#include "controller.hpp"


controller::mode_switch::mode_switch(controller* parent) : QWidget(parent){
	//TODO: Magic Numbers
    resize(195, 200);
    move(5, 65);
    
    QLabel* mode_label = new QLabel("Right-Click Mode", this);
    mode_label->setAlignment(Qt::AlignLeft);
    mode_label->setAlignment(Qt::AlignVCenter);
    mode_label->setFixedSize(200, 25);
    
    rem_node_radio = new QRadioButton("Remove Nodes", this);
    rem_node_radio->move(0, 25);
    QRadioButton::connect(rem_node_radio, &QRadioButton::clicked, this, &mode_switch::to_rem_node);
    rem_node_radio->toggle();
    
    add_edge_radio = new QRadioButton("Add Edges", this);
    add_edge_radio->move(0, 50);
    QRadioButton::connect(add_edge_radio, &QRadioButton::clicked, this, &mode_switch::to_add_edge);
    
    rem_edge_radio = new QRadioButton("Remove Edges", this);
    rem_edge_radio->move(0, 75);
    QRadioButton::connect(rem_edge_radio, &QRadioButton::clicked, this, &mode_switch::to_rem_edge);

    show();
}


controller* controller::mode_switch::get_controller(){
	return qobject_cast<controller*>(parent());
}


void controller::mode_switch::to_rem_node(){ get_controller()->mode = REM_NODE; }
void controller::mode_switch::to_add_edge(){ get_controller()->mode = ADD_EDGE; }
void controller::mode_switch::to_rem_edge(){ get_controller()->mode = REM_EDGE; }