#include "controller.hpp"


controller::node_label::node_label(const QString &text, graph_area* parent, uint32_t node) : QLabel(text, parent){
	index = node;
    setAlignment(Qt::AlignCenter);
    setFixedSize(30, 30); //TODO: Magic Number
	move(0, 0);
	show();
}


void controller::node_label::style(string outline, string color){
	current_color = color;
	setStyleSheet(QString::fromStdString(
		"QLabel {"
			"background-color: " + color + ";" +
			outline +
			"border-radius: 15" //TODO: Magic Number
		"}"
	));
}


void controller::node_label::color(string color){ style("border: 2px solid black;", color); }
void controller::node_label::select(){ style("border: 2px solid black;", current_color); }
void controller::node_label::deselect(){ style("", current_color); }
void controller::node_label::highlight(){ style("border: 2px solid white;", current_color); }


void controller::node_label::mousePressEvent(QMouseEvent *event){
	auto cont = qobject_cast<controller*>(parent()->parent());
	switch(event->button()){
		case Qt::LeftButton: cont->sel_node(index); break;
		case Qt::RightButton: cont->right_click(index); break;
		default: break;
	}
}