#include "controller.hpp"


controller::selected_pane::selected_pane(controller* parent) : QWidget(parent){
	resize(195, 200);
    move(5, 190);


    QLabel* sel_label = new QLabel("Selected Node", this);
    sel_label->setAlignment(Qt::AlignLeft);
    sel_label->setAlignment(Qt::AlignVCenter);
    sel_label->setFixedSize(200, 25);


    auto colors = new vector<tuple<const char*,const string>>({
    	{"R", "#e50000"}, {"O", "#ff8d00"}, {"Y", "#ffee00"}, {"G", "#028121"}, {"B", "#004cff"}, {"P", "#770088"}});
    
    uint64_t x=0, i=0;
    for(auto &[c, hex] : *colors){
    	auto button = new QPushButton(c, this);
    	button->setGeometry(x, 25, 28, 25);
    	QPushButton::connect(button, &QPushButton::clicked, this, [&](){
    		get_controller()->color_node(hex);
    	});

    	auto label = new QLabel("", button);
    	label->setFixedSize(20, 20);
    	label->move(4, 3);
    	label->setStyleSheet(QString::fromStdString(
			"QLabel {"
				"background-color: " + hex + ";" +
				"border-radius: 10" //TODO: Magic Number
			"}"
		));

    	x += 28 + 4+((i++)%2);
    }
    

    color_text_box = new QLineEdit(this);
    color_text_box->move(0, 55);
    color_text_box->setFixedSize(92, 25);
    color_text_box->setPlaceholderText("Hex Color");
    auto set_color = new QPushButton("Set Color", this);
    set_color->move(0, 85);
    set_color->setFixedSize(92, 25);
    QPushButton::connect(set_color, &QPushButton::clicked, this, [&](){
		get_controller()->color_node("#" + color_text_box->text().toStdString());
	});

    label_text_box = new QLineEdit(this);
    label_text_box->move(97, 55);
    label_text_box->setFixedSize(93, 25);
    label_text_box->setPlaceholderText("Label");
	auto set_label = new QPushButton("Set Label", this);
    set_label->move(97, 85);
    set_label->setFixedSize(93, 25);
    QPushButton::connect(set_label, &QPushButton::clicked, this, [&](){
		get_controller()->set_node_label(label_text_box->text().toStdString());
	});

    show();
}


controller* controller::selected_pane::get_controller(){
	return qobject_cast<controller*>(parent());
}